package ch.unige.solidify.auth;

import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.stereotype.Component;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Authenticated annotation. If the user is authenticated move on, otherwise stop.
 * <p>
 * Warning: --------- Only one security annotation per method
 */
@Component
@Retention(RetentionPolicy.RUNTIME)
@Target({ ElementType.TYPE, ElementType.METHOD })
@PreAuthorize("isFullyAuthenticated()")
public @interface Authenticated {
}
