package ch.unige.solidify.auth;

import java.util.Collection;

import org.springframework.security.core.Authentication;
import org.springframework.security.core.GrantedAuthority;

public class SsoAuthentication implements Authentication {
  private static final long serialVersionUID = 6547128854344777287L;

  private SsoUserDetails userDetails;

  public SsoAuthentication(SsoUserDetails userDetails) {
    this.userDetails = userDetails;
  }

  @Override
  public Collection<? extends GrantedAuthority> getAuthorities() {
    return userDetails.getAuthorities();
  }

  @Override
  public Object getCredentials() {
    return userDetails.getPassword();
  }

  @Override
  public Object getDetails() {
    return null;
  }

  @Override
  public Object getPrincipal() {
    return userDetails;
  }

  @Override
  public boolean isAuthenticated() {
    return userDetails != null;
  }

  @Override
  public void setAuthenticated(boolean b) {
    if (!b) {
      userDetails = null;
    } else {
      throw new IllegalStateException("setAuthenticated");
    }
  }

  @Override
  public String getName() {
    return userDetails.getUniqueId();
  }
}
