package ch.unige.solidify.auth.config;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * Defintion of mapping between Application role and Grouper group
 */
@Component
@ConfigurationProperties("sol.sso")
public class SsoAppConfig implements Serializable {
  private static final long serialVersionUID = -8901249608645308412L;

  private String context;
  private List<Group> groups = new ArrayList<>();
  private String oidcServerUrl;

  public String getOidcServerUrl() {
    return oidcServerUrl;
  }

  public void setOidcServerUrl(String oidcServerUrl) {
    this.oidcServerUrl = oidcServerUrl;
  }
  public List<Group> getGroups() {
    return groups;
  }

  public void setGroups(List<Group> groups) {
    this.groups = groups;
  }

  public String getContext() {
    return context;
  }

  public void setContext(String context) {
    this.context = context;
  }



  public static class Group implements Serializable {
    private static final long serialVersionUID = -348042870741690231L;
    private String role;
    private String org = "unige.ch";
    private String criteria = "isMemberOf";
    private List<String> criteriaValues = new ArrayList<>();

    public List<String> getCriteriaValues() {
      return criteriaValues;
    }

    public void setCriteriaValues(List<String> criteriaValues) {
      this.criteriaValues = criteriaValues;
    }

    public String getRole() {
      return role;
    }

    public void setRole(String role) {
      this.role = role;
    }

    public String getOrg() {
      return org;
    }

    public void setOrg(String org) {
      this.org = org;
    }

    public String getCriteria() {
      return criteria;
    }

    public void setCriteria(String criteria) {
      this.criteria = criteria;
    }

    public boolean isValid() {
      return this.role == null || this.criteriaValues == null || this.criteriaValues.isEmpty();
    }
  }
}
