package ch.unige.solidify.auth.shibboleth;

import java.io.Serializable;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

/**
 * Shibboleth header configuration
 */
@Component
@PropertySource("classpath:ShibboHeaderName.properties")
@ConfigurationProperties("shibboleth.header.name")
public class ShibbolethHeaderConfig implements Serializable {
  private static final long serialVersionUID = 6143469314157363548L;

  /**
   * Adding default values for the test client, not very good
   */

  private String lastName;
  private String firstName;
  private String affiliation;
  private String email;
  private String uniqueId;
  private String isMemberOf;
  private String organization;
  private String organizationType;
  private String employeeType;
  private String unigeChOuCode;
  private String unigeChStudentOuCode;
  private String unigeChEmployeeOuCode;
  private String unigeChStudentCategory;
  private String orgunitdn;
  private String matriculationnumber;
  private String cnindividu;

  public String getMatriculationnumber() {
    return matriculationnumber;
  }

  public void setMatriculationnumber(String matriculationnumber) {
    this.matriculationnumber = matriculationnumber;
  }

  public String getCnindividu() {
    return cnindividu;
  }

  public void setCnindividu(String cnindividu) {
    this.cnindividu = cnindividu;
  }

  public String getOrgunitdn() {
    return orgunitdn;
  }

  public void setOrgunitdn(String orgunitdn) {
    this.orgunitdn = orgunitdn;
  }

  public String getIsMemberOf() {
    return isMemberOf;
  }

  public void setIsMemberOf(String isMemberOf) {
    this.isMemberOf = isMemberOf;
  }

  public String getLastName() {
    return lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  public String getFirstName() {
    return firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public String getEmail() {
    return email;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  public String getUniqueId() {
    return uniqueId;
  }

  public void setUniqueId(String uniqueId) {
    this.uniqueId = uniqueId;
  }

  public String getOrganization() {
    return organization;
  }

  public void setOrganization(String organization) {
    this.organization = organization;
  }

  public String getOrganizationType() {
    return organizationType;
  }

  public void setOrganizationType(String organizationType) {
    this.organizationType = organizationType;
  }

  public String getAffiliation() {
    return affiliation;
  }

  public void setAffiliation(String affiliation) {
    this.affiliation = affiliation;
  }

  public String getEmployeeType() {
    return employeeType;
  }

  public void setEmployeeType(String employeeType) {
    this.employeeType = employeeType;
  }

  public String getUnigeChOuCode() {
    return unigeChOuCode;
  }

  public void setUnigeChOuCode(String unigeChOuCode) {
    this.unigeChOuCode = unigeChOuCode;
  }

  public String getUnigeChStudentOuCode() {
    return unigeChStudentOuCode;
  }

  public void setUnigeChStudentOuCode(String unigeChStudentOuCode) {
    this.unigeChStudentOuCode = unigeChStudentOuCode;
  }

  public String getUnigeChEmployeeOuCode() {
    return unigeChEmployeeOuCode;
  }

  public void setUnigeChEmployeeOuCode(String unigeChEmployeeOuCode) {
    this.unigeChEmployeeOuCode = unigeChEmployeeOuCode;
  }

  public String getUnigeChStudentCategory() {
    return unigeChStudentCategory;
  }

  public void setUnigeChStudentCategory(String unigeChStudentCategory) {
    this.unigeChStudentCategory = unigeChStudentCategory;
  }

}
