package ch.unige.solidify.auth.util;

import java.util.Arrays;
import java.util.Map;

import org.springframework.core.env.Environment;

import ch.unige.solidify.auth.config.SsoAppConfig;
import ch.unige.solidify.model.sso.SsoUser;

public class AuthUtility {

  public static String calculeUserContext(Map<String, String> attributes, SsoAppConfig appConfig) {
    String context = appConfig.getContext();
    if (context == null && attributes != null) {
      context = attributes.get(SsoUser.CONNECTED_USER_CONTEXT_SOURCE_NAME);
    }
    return context;
  }

  public static boolean isProfilesActive( Environment environment, String... profileNames){
    if(profileNames==null || profileNames.length<1){
      return false;
    }
    for( String profile : profileNames){
      boolean found=Arrays.stream(environment.getActiveProfiles())
              .anyMatch(env -> (env.equalsIgnoreCase(profile))  );
      if(found){
        return true;
      }
    }
    return false;
  }



}
