package ch.unige.solidify.auth.util;

import java.io.Serializable;
import java.util.Map;
import java.util.Set;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

import ch.unige.solidify.model.sso.SsoUser;

/**
 * Contains user's data. Properties are read/write, useful for testing purposes.
 */
@JsonIgnoreProperties(ignoreUnknown = true)
public class SsoUserData extends SsoUser implements Serializable {
  private static final long serialVersionUID = 8148666699346592155L;

  public void setAllProperties(Map<String, String> allProperties) {
    super.allProperties = allProperties;
  }

  public void setUserContext(String userContext) {
    super.userContext = userContext;
  }

  public void setOauthToken(String oauthToken) {
    super.oauthToken = oauthToken;
  }

  public void setOauthTokenExpiresTime(long oauthTokennExpiresTime) {
    super.oauthTokenExpiresTime = oauthTokennExpiresTime;
  }

  public void setSystemId(long systemId) {
    super.systemId = systemId;
  }

  public void setFirstname(String firstname) {
    super.firstName = firstname;
  }

  public void setLastname(String lastname) {
    super.lastName = lastname;
  }

  public void setAffiliation(Set<String> affiliation) {
    super.affiliation = affiliation;
  }

  public void setEmail(String email) {
    super.email = email;
  }

  public void setHomeorganization(String homeorganization) {
    super.homeorganization = homeorganization;
  }

  public void setHomeorganizationtype(String homeorganizationtype) {
    super.homeorganizationtype = homeorganizationtype;
  }

  public void setIsmemberOf(Set<String> ismemberOf) {
    super.ismemberOf = ismemberOf;
  }

  public void setEmployeeType(Set<String> employeeType) {
    super.employeeType = employeeType;
  }

  public void setUnigechoucode(String unigechoucode) {
    super.unigechoucode = unigechoucode;
  }

  public void setUnigechstudentoucode(String unigechstudentoucode) {
    super.unigechstudentoucode = unigechstudentoucode;
  }

  public void setUnigechemployeeoucode(String unigechemployeeoucode) {
    super.unigechemployeeoucode = unigechemployeeoucode;
  }

  public void setUniqueid(String uniqueid) {
    super.uniqueId = uniqueid;
  }

  public void setUnigeChStudentCategory(Set<String> unigeChStudentCategory) {
    super.unigeChStudentCategory = unigeChStudentCategory;
  }

  public void setOrgunitdn(String orgunitdn) {
    super.orgunitdn = orgunitdn;
  }

  public void setMatriculationnumber(String matriculationnumber) {
    super.matriculationnumber = matriculationnumber;
  }

  public void setCnindividu(String cnindividu) {
    super.cnindividu = cnindividu;
  }

  public void setName(String name) {
    super.name = name;
  }

  public void setRoles(Set<String> roles) {
    super.roles = roles;
  }

  @Override
  public String toString() {
    return "SsoUserData{" +
            "userContext='" + userContext + '\'' +
            ", firstName='" + firstName + '\'' +
            ", lastName='" + lastName + '\'' +
            ", email='" + email + '\'' +
            ", homeorganization='" + homeorganization + '\'' +
            ", homeorganizationtype='" + homeorganizationtype + '\'' +
            ", affiliation='" + affiliation + '\'' +
            ", ismemberOf=" + ismemberOf +
            ", employeeType=" + employeeType +
            ", unigechoucode='" + unigechoucode + '\'' +
            ", unigechstudentoucode='" + unigechstudentoucode + '\'' +
            ", unigechemployeeoucode='" + unigechemployeeoucode + '\'' +
            ", uniqueId='" + uniqueId + '\'' +
            ", unigeChStudentCategory=" + unigeChStudentCategory +
            ", orgunitdn='" + orgunitdn + '\'' +
            ", matriculationnumber='" + matriculationnumber + '\'' +
            ", name='" + name + '\'' +
            ", roles=" + roles +
            ", systemId=" + systemId +
            ", oauthToken=" + oauthToken +
            ", oauthTokenExpiresTime='" + oauthTokenExpiresTime + '\'' +
            ", cnindividu=" + cnindividu +
            '}';
  }

}
