package ch.unige.solidify.test.auth;

import static org.hamcrest.CoreMatchers.is;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.content;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.jsonPath;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.servlet.MockMvc;

import ch.unige.solidify.auth.util.WithSsoMockUser;
import ch.unige.solidify.test.auth.config.MockApplication;

/**
 * this class is used to test the 2 mock tools WithSsoMockUser and MockSsoUserSecurityContextFactory
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = MockApplication.class)
@AutoConfigureMockMvc
@WithSsoMockUser(uniqueid = "123456@unige.ch", cnindividu = "123456", userContext = "ETU", name = "Test", roles = {
        "editor" }, allPropertiesName = { "unigechemployeeuid",
                "unigechstudentuid" }, allPropertiesValue = { "wangr", "testw" })
public class AuthMockToollTest {

  @Autowired
  private MockMvc mockMvc;

  @Test
  public void testLoggedUser() throws Exception {
    mockMvc.perform(get("/api/user")).andExpect(status().isOk())
            .andExpect(content().contentType("application/json"))
            .andExpect(jsonPath("userContext", is("ETU")))
            .andExpect(jsonPath("uniqueId", is("123456@unige.ch")))
            .andExpect(jsonPath("cnindividu", is("123456")));
  }

}
