package ch.unige.solidify.test.auth.controllers;

import ch.unige.solidify.auth.Authenticated;
import ch.unige.solidify.auth.SsoUserDetails;
import org.springframework.http.MediaType;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController

@RequestMapping(value = "api", produces = MediaType.APPLICATION_JSON_VALUE)
public class MockUserController {

  @GetMapping("/user")
  @Authenticated
  @PreAuthorize("hasRole('editor')")
  public SsoUserDetails currentUser() {
    return (SsoUserDetails) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
  }

  @GetMapping("/greet")
  public String greeting() {
    return "hello";
  }

  @Authenticated
  @GetMapping("/internalInfo")
  public String getInternalInfo() {
    return "you are full authetificated";
  }

}
