package ch.unige.solidify.test.auth.data;

import java.util.HashMap;
import java.util.Map;

import ch.unige.solidify.model.sso.SsoUser;

public class MockData {

  public static String employeeNumber = "135192";
  public static String matriculationNumber = "1234567";
  public static String ShibboUniqueId = employeeNumber + "@unige.ch";
  public static long ShibboSystemId = 135192;
  public static String OcidcId = "747918@unige.ch";
  public static String oauthAccessToken = "ef5be4b9-7270-4d0a-bc32-0f8b1807fd38";
  public static long oauthAccessTokenExpires = 1557008476;

  private static Map<String, String> shibboHeadersMockData = new HashMap<>();

  private static Map<String, Object> oidcHeadersMockData = new HashMap<>();

  static {
    oidcHeadersMockData.put("oidc_access_token", oauthAccessToken);
    oidcHeadersMockData.put("oidc_claim_sub", OcidcId);
    oidcHeadersMockData.put("OIDC_access_token_expires", oauthAccessTokenExpires);
    oidcHeadersMockData.put(SsoUser.CONNECTED_USER_UNIQUE_ID, "123");
    shibboHeadersMockData.put("ismemberof", "adm:editor;adm:admin;");
    shibboHeadersMockData.put("homeorganization", "unige.ch");
    shibboHeadersMockData.put("givenname", "TEST-prénoms");
    shibboHeadersMockData.put("surname", "TEST-nom");
    shibboHeadersMockData.put("uniqueId", ShibboUniqueId);
    shibboHeadersMockData.put("mail", "test@unige.ch");
    shibboHeadersMockData.put("homeorganizationtype", "university");
    shibboHeadersMockData.put("affiliation", "staff;student");
    shibboHeadersMockData.put("employeetype", "etu;pat;ens");
    shibboHeadersMockData.put("unigechoucode", "");
    shibboHeadersMockData.put("unigechstudentoucode", "");
    shibboHeadersMockData.put("unigechemployeeoucode", "");
    shibboHeadersMockData.put("unigechstudentcategory", "master;mobile");
    shibboHeadersMockData.put("orgunit-dn", "ou=acad,ou=block,o=unige");
    shibboHeadersMockData.put("matriculationnumber", matriculationNumber);
    shibboHeadersMockData.put("employeenumber", "132458");
    shibboHeadersMockData.put("unigechemployeeuid", "wangr");
  }

  public static Map<String, String> getShibboHeadersMockData() {
    return shibboHeadersMockData;
  }

  public static Map<String, Object> getOidcHeadersMockData() {
    return oidcHeadersMockData;
  }

}
