package ch.unige.solidify.test.util;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.core.env.Environment;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.junit4.SpringRunner;

import ch.unige.solidify.auth.config.SsoAppConfig;
import ch.unige.solidify.auth.util.OIDCUtil;
import ch.unige.solidify.test.auth.config.MockApplication;

@RunWith(SpringRunner.class)
@SpringBootTest(classes = MockApplication.class)
@ActiveProfiles({ "qa" })
public class OIDCUtilTestQa {
  private String qaDefinedValue = "http://localhost/mockOidcServer";
  @Autowired
  Environment environment;

  @Autowired
  private SsoAppConfig ssoAppConfig;

  @Test
  public void getOidcServerUrl_dev_profil() {
    String url = OIDCUtil.getOidcServerUrl(environment, ssoAppConfig);
    Assert.assertEquals(qaDefinedValue, url);
  }
}
