package ch.unige.solidify.controller;



import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.hateoas.Link;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.config.SolidifyProperties;
import ch.unige.solidify.model.Module;
import ch.unige.solidify.rest.ActionName;
import ch.unige.solidify.rest.Resource;
import ch.unige.solidify.service.ModuleService;

@RestController
public class ApplicationController {

  @Autowired
  ModuleService<? extends Resource<?>> moduleService;

  @Autowired
  private SolidifyProperties config;

  @RequestMapping(SolidifyConstants.URL_SEP)
  public HttpEntity<Module> home() {
    Module backend = new Module(config.getServerDisplayName());
    backend.add(linkTo(methodOn(ApplicationController.class).home()).withSelfRel());
    backend.add(new Link(linkTo(methodOn(ApplicationController.class).home())
            + ActionName.DASHBOARD.toLowerCase()).withRel(ActionName.DASHBOARD));
    for (ModuleController module : moduleService.getModuleControllerList()) {
      backend.add(linkTo(methodOn(module.getClass()).home()).withRel(module.getName()));
    }
    return new ResponseEntity<>(backend, HttpStatus.OK);
  }

}
