package ch.unige.solidify.util;

/**
 * Different operation types, used by SearchCriteria
 *
 * @see ch.unige.solidify.util.SearchCriteria
 */
public enum SearchOperation {
  EQUALITY, NEGATION, GREATER_THAN, LESS_THAN, CONTAINS, STARTS_WITH, ENDS_WITH, GREATER_EQUAL, LESS_EQUAL, BETWEEN, ORACLE_CONTAINS;

  public static final String[] OPERATION_SET = { ":", "!", ">", "<", "~", "¬", "§", "≥", "≤", "∞", "¢" };
  public static final String OR_PREDICATE_FLAG = "any";
  public static final String CASE_INSENSITIVE_FLAG = "i";

  public static SearchOperation getOperation(final String input) {
    switch (input) {
      case ":":
        return EQUALITY;
      case "!":
        return NEGATION;
      case ">":
        return GREATER_THAN;
      case "<":
        return LESS_THAN;
      case "~":
        return CONTAINS;
      case "¬":
        return STARTS_WITH;
      case "§":
        return ENDS_WITH;
      case "≥":
        return GREATER_EQUAL;
      case "≤":
        return LESS_EQUAL;
      case "∞":
        return BETWEEN;
      case "¢":
        return ORACLE_CONTAINS;
      default:
        return null;
    }
  }
}
