package ch.unige.solidify;

public class SolidifyConstants {

  private SolidifyConstants() {
    throw new IllegalStateException(TOOL_CLASS);
  }

  public static final String TOOL_CLASS = "Utility class";
  public static final String MANIFEST = "/META-INF/MANIFEST.MF";

  // Separators
  public static final String VALUE_SEP = "=";
  public static final String FIELD_SEP = ";";
  public static final String ID_SEP = "-";
  public static final String ID_CONCAT = "+";

  // URL
  public static final String URL_SEP = "/";
  public static final String URL_ID_FIELD = "id";
  public static final String URL_PARENT_ID_FIELD = "parentid";
  public static final String URL_ID = URL_SEP + "{" + URL_ID_FIELD + "}";
  public static final String URL_ID_PLUS_SEP = URL_ID + URL_SEP;
  public static final String URL_PARENT_ID = URL_SEP + "{" + URL_PARENT_ID_FIELD + "}" + URL_SEP;
  public static final String URL_DASHBOARD = URL_SEP + "dashboard";

  // Prefix
  public static final String BASE64_PREFIX = "{base64}";

  // Security
  public static final String NO_CREDENTIAL = "Anonymous";

  // Extension
  public static final String XML_MIME_TYPE = "application/xml";
  public static final String ZIP_MIME_TYPE = "application/zip";
  public static final String ZIP_EXT = ".zip";
  public static final String XML_EXT = ".xml";
  public static final String XSD_EXT = ".xsd";
  public static final String XML_OUTPUT_EXT = "-out.xml";

  // XML
  public static final String SCHEMA_HOME = "schemas";

}
